Type TLight extends TEntity

	Function CreateSpotLight:TLight()
		Local L:TLight = New TLight
		L.max3d_ptr = bmx3d.max3d.CreateSpotLight()
		Return L
	End Function

	Function CreatePointLight:TLight()
		Local L:TLight = New TLight
		L.max3d_ptr = bmx3d.max3d.CreatePointLight()
		Return L
	End Function

	Function CreateDistantLight:TLight()
		Local L:TLight = New TLight
		L.max3d_ptr = bmx3d.max3d.CreateDistantLight()
		Return L
	End Function

	Method SetAngle(angle:Float)
		bmx3d.max3d.SetLightAngle(max3d_ptr,angle)
	End Method

	Method SetRange(range:Float)
		bmx3d.max3d.SetLightRange(max3d_ptr,range)
	End Method

	Method SetColor(red:Float,green:Float,blue:Float)
		bmx3d.max3d.SetLightColor(max3d_ptr,red,green,blue)
	End Method

	Method SetTexture(texture:TTexture)
		bmx3d.max3d.SetLightTexture(max3d_ptr,texture.max3d_ptr)
	End Method

	Method SetShadowSize(size:Int)
		bmx3d.max3d.SetLightShadowSize(max3d_ptr,size)
	End Method

	Method SetShadowSplits(splitCount:Int,znear:Float,zfar:Float,blend:Float)
		bmx3d.max3d.SetLightShadowSplits(max3d_ptr,splitCount,znear,zfar,blend)
	End Method

	Method SetShadowSplitsTable(floatCount:Int,floats:Byte Ptr)
		bmx3d.max3d.SetLightShadowSplitsTable(max3d_ptr,floatCount,floats)
	End Method

End Type

