Type TModel extends TEntity

	Function Load:TModel(path:String,collType:Int,mass:Float)
		Local M:TModel = New TModel
		M.max3d_ptr = bmx3d.max3d.LoadModel(path,collType,mass)
		Return M
	End Function

	Function Create:TModel()
		Local M:TModel = New TModel
		M.max3d_ptr = bmx3d.max3d.CreateModel()
		Return M
	End Function

	Function CreateSphere:TModel(material:TMaterial,radius:Float,collType:Int,mass:Float)
		Local M:TModel = New TModel
		M.max3d_ptr = bmx3d.max3d.CreateSphere(material.max3d_ptr,radius,collType,mass)
		Return M
	End Function

	Function CreateCapsule:TModel(material:TMaterial,radius:Float,length:Float,collType:Int,mass:Float)
		Local M:TModel = New TModel
		M.max3d_ptr = bmx3d.max3d.CreateCapsule(material.max3d_ptr,radius,length,collType,mass)
		Return M
	End Function

	Function CreateCylinder:TModel(material:TMaterial,radius:Float,length:Float,collType:Int,mass:Float)
		Local M:TModel = New TModel
		M.max3d_ptr = bmx3d.max3d.CreateCylinder(material.max3d_ptr,radius,length,collType,mass)
		Return M
	End Function

	Function CreateBox:TModel(material:TMaterial,width:Float,height:Float,depth:Float,collType:Int,mass:Float)
		Local M:TModel = New TModel
		M.max3d_ptr = bmx3d.max3d.CreateBox(material.max3d_ptr,width,height,depth,collType,mass)
		Return M
	End Function

	Method AddSurface(surface:TModelSurface)
		bmx3d.max3d.AddModelSurface(max3d_ptr,surface.max3d_ptr)
	End Method

	Method UpdateNormals()
		bmx3d.max3d.UpdateModelNormals(max3d_ptr)
	End Method

	Method UpdateTangents()
		bmx3d.max3d.UpdateModelTangents(max3d_ptr)
	End Method

	Method ScaleTexCoords(s_scale:Float,t_scale:Float)
		bmx3d.max3d.ScaleModelTexCoords(max3d_ptr,s_scale,t_scale)
	End Method

	Method ResetTransform()
		bmx3d.max3d.ResetModelTransform(max3d_ptr)
	End Method

	Method Flip()
		bmx3d.max3d.FlipModel(max3d_ptr)
	End Method

End Type

