Type TTexture extends TResource

	Function Load:TTexture(path$) 
		Local T:TTexture = New TTexture
		T.max3d_ptr = bmx3d.max3d.LoadTexture(path$) 
		Return T
	End Function

	Function LoadCube:TTexture(path$) 
		Local T:TTexture = New TTexture
		T.max3d_ptr = bmx3d.max3d.LoadCubeTexture(path$) 
		Return T
	End Function

	Function Black:TTexture()
		Local T:TTexture = New TTexture
		T.max3d_ptr = bmx3d.max3d.BlackTexture()
		Return T
	End Function

	Function White:TTexture()
		Local T:TTexture = New TTexture
		T.max3d_ptr = bmx3d.max3d.WhiteTexture()
		Return T
	End Function

	Function Create:TTexture(width:Int,height:Int,format:Int,flags:Int)
		Local T:TTexture = New TTexture
		T.max3d_ptr = bmx3d.max3d.CreateTexture(width,height,format,flags)
		Return T
	End Function

	Function Create3d:TTexture(width:Int,height:Int,depth:Int,format:Int,flags:Int)
		Local T:TTexture = New TTexture
		T.max3d_ptr = bmx3d.max3d.Create3dTexture(width,height,depth,format,flags)
		Return T
	End Function

	Function CreateCube:TTexture(size:Int,format:Int,flags:Int)
		Local T:TTexture = New TTexture
		T.max3d_ptr = bmx3d.max3d.CreateCubeTexture(size,format,flags)
		Return T
	End Function

	Method SetPath(path:String)
		bmx3d.max3d.SetTexturePath(max3d_ptr,path)
	End Method

	Method SetData(data:Byte Ptr)
		bmx3d.max3d.SetTextureData(max3d_ptr,data)
	End Method

	Method Set3dData(data:Byte Ptr)
		bmx3d.max3d.Set3dTextureData(max3d_ptr,data)
	End Method

	Method SetCubeData(data:Byte Ptr)
		bmx3d.max3d.SetCubeTextureData(max3d_ptr,data)
	End Method

End Type

